function [ R ] = Rate_AQNM(SP, H, Wrf, a)

p = SP.p;
Nu = SP.Nu;
BBcombiner = SP.BBcombiner;

% Digital Combiner
Heq = Wrf'*H;
[r, ~] = size(Heq);
Rqq = a*(1-a)*diag(diag(p*Heq*Heq' + Wrf'*Wrf));
switch BBcombiner
    case 'mrc'
        Wbb = Heq;
    case 'zf'
        Wbb = pinv(Heq)';
    case 'mmse'
        Ryx = a*p*Heq;
        Ryy = a^2*p*Heq*Heq' + a^2*Wrf'*Wrf + Rqq;
        Wbb = pinv(Ryy)*Ryx; 
end

for k = 1:Nu
    wk = Wbb(:,k);
    SigPow = a^2*p*abs(wk'*Heq(:,k))^2;
    NoisPow = a^2*p*(sum(abs(wk'*Heq).^2)-abs(wk'*Heq(:,k))^2) + a^2*norm(Wrf*wk)^2 + wk'*Rqq*wk;
    r(k) = log2( 1 + SigPow/NoisPow );
end

R = sum(r);

end

